//########## Failnaid (Fail Grenade)

//### Sound

datablock AudioProfile(grenadePullSound)
{
  filename = "./grenadePull.wav";
  description = AudioClose3d;
  preload = true;
};

datablock AudioProfile(failExplosionSound)
{
  filename = "./explosion.wav";
  description = AudioDefault3d;
  preload = true;
};

//### Effects

datablock ParticleData(failSmokeParticle)
{
  dragCoefficient = 3;
  gravityCoefficient = 0;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 5000;
  lifetimeVarianceMS = 0;
  textureName = "./fail.png";
  spinSpeed = 10.0;
  spinRandomMin = -50.0;
  spinRandomMax = 50.0;
  colors[0] = "0.4 0.4 0.4 0.6";
  colors[1] = "0.2 0.2 0.2 0";
  sizes[0] = 10;
  sizes[1] = 20;
  useInvAlpha = true;
};

datablock ParticleEmitterData(failSmokeEmitter)
{
   uiName = "";
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 1;
   ejectionOffset = 3;
   thetaMin = 89;
   thetaMax = 90;
   phiReferenceVel = 0;
   phiVariance = 360;
   overrideAdvance = false;
   particles = "failSmokeParticle";
   emitterNode = TenthEmitterNode;
};

datablock ParticleData(failExplosionParticle)
{
  dragCoefficient = 8;
  gravityCoefficient = -0.5;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 50;
  lifetimeVarianceMS = 0;
  textureName = "./failcloud.png";
  spinSpeed = 10;
  spinRandomMin = -500;
  spinRandomMax = 500;
  colors[0] = "1 0.6 0.2 1";
  colors[1] = "1 0 0 0";
  sizes[0] = 5;
  sizes[1] = 10;
  useInvAlpha = false;
};

datablock ParticleEmitterData(failExplosionEmitter)
{
  uiName = "";
  lifeTimeMS = 50;
  ejectionPeriodMS = 1;
  periodVarianceMS = 0;
  ejectionVelocity = 5;
  velocityVariance = 0;
  ejectionOffset = 3;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = true;
  particles = "failExplosionParticle";
};

datablock ExplosionData(failExplosion)
{
  soundProfile = failExplosionSound;
  lifeTimeMS = 150;
  particleEmitter = failSmokeEmitter;
  particleDensity = 10;
  particleRadius = 0.2;
  emitter[0] = failExplosionEmitter;
  faceViewer = true;
  explosionScale = "1 1 1";
  shakeCamera = true;
  camShakeFreq = "10 10 10";
  camShakeAmp = "3 10 3";
  camShakeDuration = 0.5;
  camShakeRadius = 10;
  lightStartRadius = 10;
  lightEndRadius = 5;
  lightStartColor = "1 0.6 0.2 1";
  lightEndColor = "1 0 0 0";
  damageRadius = 10;
  radiusDamage = 1000;
  impulseRadius = 5;
  impulseForce = 2500;
};

//### Projectile

AddDamageType("Fail",'<bitmap:Add-ons/Weapon_Failnaid/CI_fail> %1','%2 <bitmap:Add-ons/Weapon_Failnaid/CI_Fail> %1',0.2,1);
AddDamageType("FailRadius",'<bitmap:Add-ons/Weapon_Failnaid/CI_failradius> %1','%2 <bitmap:Add-ons/Weapon_Failnaid/CI_failradius> %1',0.2,1);

datablock ProjectileData(failProjectile)
{
  uiName = "Fail Grenade";
  projectileShapeName = "./failnaid.dts";
  directDamage = 0;
  directDamageType = $DamageType::Fail;
  radiusDamageType = $DamageType::FailRadius;
  brickExplosionRadius = 5;
  brickExplosionImpact = false;
  brickExplosionForce = 30;
  brickExplosionMaxVolume = 100;
  brickExplosionMaxVolumeFloating = 100;
  impactImpulse = 1000;
  verticalImpulse = 100;
  explosion = failExplosion;
  particleEmitter = spearTrailEmitter;
  muzzleVelocity = 40;
  verInheritFactor = 1;
  armingDelay = 3000;
  lifetime = 3000;
  fadeDelay = 3000;
  bounceAngle= 170;
  bounceElasticity = 0.4;
  bounceFriction = 0.2;
  isBallistic = true;
  gravityMod = 1;
  explodeOnDeath = true;
  hasLight = false;
  lightRadius = 6;
  lightColor = "1 0.5 0";
};

//### Item

datablock ItemData(failfruitItem)
{
  uiName = "Fail Grenade";
  iconName = "./failnaid";
  image = failImage;
  category = "Weapon";
  className = "Weapon";
  shapeFile = "./failnaid.dts";
  mass = 0.3;
  density = 0.2;
  elasticity = 0;
  friction = 0.6;
  emap = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";
  canDrop = true;
};

//### Item Image

datablock ShapeBaseImageData(failImage)
{
  shapeFile = "./failnaid.dts";
  emap = true;
  mountPoint = 0;
  offset = "0 0 0";
  correctMuzzleVector = true;
  eyeOffset = "0 0 0";
  rotation = eulerToMatrix("0 0 0");
  className = "WeaponImage";
  item = failItem;
  ammo = " ";
  projectile = failProjectile;
  projectileType = Projectile;
  melee = false;
  doReaction = false;
  armReady = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";

  stateName[0] = "Activate";
  stateTimeoutValue[0] = 0.2;
  stateTransitionOnTimeout[0] = "Ready";
  stateSound[0] = weaponSwitchSound;

  stateName[1] = "Ready";
  stateTransitionOnTriggerDown[1] = "Charge";
  stateAllowImageChange[1] = true;
	
  stateName[2] = "Charge";
  stateTransitionOnTimeout[2] = "Armed";
  stateTimeoutValue[2] = 0.3;
  stateWaitForTimeout[2] = false;
  stateTransitionOnTriggerUp[2] = "AbortCharge";
  stateScript[2] = "onCharge";
  stateAllowImageChange[2] = false;
  stateSound[2] = grenadePullSound;

  stateName[3] = "AbortCharge";
  stateTransitionOnTimeout[3] = "Ready";
  stateTimeoutValue[3] = 0.3;
  stateWaitForTimeout[3] = true;
  stateScript[3] = "onAbortCharge";
  stateAllowImageChange[3] = false;

  stateName[4] = "Armed";
  stateTransitionOnTriggerUp[4] = "Fire";
  stateAllowImageChange[4] = false;

  stateName[5] = "Fire";
  stateTransitionOnTimeout[5] = "Done";
  stateTimeoutValue[5] = 0.4;
  stateFire[5] = true;
  stateSequence[5] = "fire";
  stateScript[5] = "onFire";
  stateWaitForTimeout[5] = true;
  stateAllowImageChange[5] = false;

  stateName[6] = "Done";
  stateScript[6] = "onDone";
  stateTransitionOnTimeout[6] = "Ready";
  stateTimeoutValue[6] = 0.01;
  stateWaitForTimeout[6] = True;
};

function failImage::onCharge(%this,%obj,%slot)
{
  %obj.playthread(2,spearReady);
  %obj.lastAGSlot = %obj.currTool;
}

function failImage::onAbortCharge(%this,%obj,%slot)
{
  %obj.playthread(2,root);
}

function failImage::onFire(%this,%obj,%slot)
{
  %obj.playthread(2,spearThrow);
  Parent::onFire(%this,%obj,%slot);
  %currSlot = %obj.lastAGSlot;
  %obj.tool[%currSlot] = 0;
  %obj.weaponCount--;
  messageClient(%obj.client,'MsgItemPickup','',%currSlot,0);
  serverCmdUnUseTool(%obj.client);
}

function failImage::onDone(%this,%obj,%slot)
{
  %obj.unMountImage(%slot);
}

package failPackage
{
  function Armor::onCollision(%this,%obj,%col,%a,%b,%c,%d,%e,%f) {
    if(%col.dataBlock $= "failItem" && %col.canPickup)
    {
      for(%i=0;%i<%this.maxTools;%i++)
      {
        %item = %obj.tool[%i];
        if(%item $= 0 || %item $= "") {
          %freeSlot = 1;
          break; }
      }
      if(%freeSlot) {
        %obj.pickup(%col);
        return; }
    }
    Parent::onCollision(%this,%obj,%col,%a,%b,%c,%d,%e,%f); }
};
activatePackage(failPackage);
